// basic functions to write directly into screen memory
// translated to D by Carlos Santander B.

/* Copyright (C) 1986-2001 by Digital Mars. $Revision: 1.1.1.1 $ */
extern (C) {	
	int
		disp_numrows,
		disp_numcols,
		disp_cursorrow,
		disp_cursorcol;
		
	short disp_nowrap;  /* does display wrap or not */
	
	int disp_printf(char *,...);
	int disp_getmode();
	int disp_getattr();
	int disp_putc(int);

	void disp_levelblockpoke(int,int,int,int,uint,uint *,uint,uint *,uint);
	void disp_open();
	void disp_puts(char *);
	void disp_box(int,int,uint,uint,uint,uint);
	void disp_close();
	
	version (Win32) {}
	else void disp_usebios();	
	
	void disp_move(int,int);
	void disp_flush();
	void disp_eeol();
	void disp_eeop();
	void disp_startstand();
	void disp_endstand();
	void disp_setattr(int);
	void disp_setcursortype(int);
	void disp_pokew(int,int,ushort);
	void disp_scroll(int,uint,uint,uint,uint,uint);
	//-------------------Doesn't work for me. Might work for you
	//void disp_setmode(int);
	void disp_peekbox(ushort *,uint,uint,uint,uint);
	void disp_pokebox(ushort *,uint,uint,uint,uint);
	
	//-------------------These two work fine in my XP box
	void disp_set43();
	void disp_reset43();
	
	void disp_fillbox(uint,uint,uint,uint,uint);
	void disp_hidecursor();
	void disp_showcursor();	
	ushort disp_peekw(int,int);

	/* Globals for IBM PC displays (read only):     */	
	ubyte
		disp_mono,
		disp_mode,
		disp_inited,
		disp_ega;
	
	uint disp_base;
		
	version (Xenix) version=UnixXenix;
	version (Unix) version=UnixXenix;
	
	version (UnixXenix) {
		ubyte disp_scomode, disp_captured;
		int disp_vt_number;
		char *disp_offset;
	} else {
		ubyte disp_snowycga;
	}
	
	const short
		DISP_REVERSEVIDEO       = 0x70,
		DISP_NORMAL             = 0x07,
		DISP_UNDERLINE          = 0x01,
		DISP_NONDISPLAY         = 0x00,
	
		DISP_INTENSITY          = 0x08,
		DISP_BLINK              = 0x80;
	
	version(Win32)
		const short
			DISP_CURSORBLOCK	= 100,
			DISP_CURSORHALF		= 50,
			DISP_CURSORUL		= 20;
	else
		const short
			DISP_CURSORBLOCK = (disp_mono ? 0x000C : 0x0007),
			DISP_CURSORHALF  = (disp_mono ? 0x060C : 0x0307),
			DISP_CURSORUL    = (disp_mono ? 0x0B0C : 0x0707);
	
	version (UnixXenix) {}
	else {
		struct disp_t {
			uint numrows;
			uint numcols;
			uint cursorrow;
			uint cursorcol;
			ubyte mono;
			ubyte snowycga;
			ubyte mode;
			ubyte inited;
			ubyte ega;
			ubyte reserved[3];
			short nowrap;
		
			union _disp {
				ushort *base;
				struct _disp1 {
					uint offset;
					ushort base;
				}
				_disp1 _disp1x;
			}
			_disp _dispx;
			version (Win32) void *handle;
		}
		
		
		disp_t disp_state;
		
		/*
		alias disp_state.numrows             disp_numrows;
		alias disp_state.numcols             disp_numcols;
		alias disp_state.cursorrow           disp_cursorrow;
		alias disp_state.cursorcol           disp_cursorcol;
		alias disp_state.mono                disp_mono;
		alias disp_state.snowycga            disp_snowycga;
		alias disp_state.mode                disp_mode;
		alias disp_state.inited              disp_inited;
		alias disp_state.ega                 disp_ega;
		alias disp_state.nowrap              disp_nowrap;
		alias disp_state._dispx._disp1x.base disp_base;
		*/
	}
}